diff --git a/tests/conftest.py b/tests/conftest.py
index 367bab260..db03c2453 100644
--- a/tests/conftest.py
+++ b/tests/conftest.py
@@ -81,6 +81,9 @@ def no_warnings(recwarn):
         elif "(rm_rf) error removing" in message:
             # First appeared with pytest 5.4.1
             continue
+        elif "resolve package from __spec__ or __package__" in message:
+            # Not related to our stuff (Peewee)
+            continue
 
         warn = f"{warning.filename}:{warning.lineno} {message}"
         print(warn, file=sys.stderr)
diff --git a/tests/functional/conftest.py b/tests/functional/conftest.py
index ef18d1e20..6671c7cfa 100644
--- a/tests/functional/conftest.py
+++ b/tests/functional/conftest.py
@@ -1,7 +1,6 @@
 # coding: utf-8
 from logging import getLogger
 from pathlib import Path
-from random import randint
 from typing import Callable, Optional
 from uuid import uuid4
 
@@ -12,6 +11,7 @@
 from nxdrive.manager import Manager
 
 from .. import env
+from ..utils import salt
 
 log = getLogger(__name__)
 
@@ -83,7 +83,8 @@ def user_factory(request, server, faker):
 
     def _make_user(username: str = "", password: str = "Administrator"):
         first_name, last_name = fake.name().split(" ", 1)
-        username = username or f"{first_name.lower()}-{randint(1, 99_999)}"
+        username = username or first_name.lower()
+        username = salt(username)
         properties = {
             "lastName": last_name,
             "firstName": first_name,
@@ -117,6 +118,7 @@ def _make(
         enable_sync: bool = False,
     ):
         title = title or str(uuid4())
+        title = salt(title)
         new = Document(name=title, type=nature, properties={"dc:title": title})
         obj = server.documents.create(new, parent_path=env.WS_DIR)
         request.addfinalizer(obj.delete)
diff --git a/tests/functional/test_direct_edit.py b/tests/functional/test_direct_edit.py
index f5b083f07..c316e23cd 100644
--- a/tests/functional/test_direct_edit.py
+++ b/tests/functional/test_direct_edit.py
@@ -20,6 +20,7 @@ def __init__(self, url: str, user: str):
         self._user = user
         self._stopped = True
         self._invalid_credentials = False
+        self.dt_manager = None
 
     def get_binder(self):
         """
diff --git a/tests/functional/test_remote_client.py b/tests/functional/test_remote_client.py
index f342b07e0..c7d5b6e35 100644
--- a/tests/functional/test_remote_client.py
+++ b/tests/functional/test_remote_client.py
@@ -6,10 +6,10 @@
 @pytest.mark.parametrize(
     "username",
     [
-        "ndt-Alice",
-        "ndt-bob@bar.com",
-        # "ndt-éléonor",
-        # "ndt-東京スカイツリー",
+        "Alice",
+        "bob@bar.com",
+        # "éléonor",
+        # "東京スカイツリー",
     ],
 )
 def test_personal_space(manager_factory, tmp, nuxeo_url, user_factory, username):
diff --git a/tests/old_functional/direct_transfer/test_signals.py b/tests/old_functional/direct_transfer/test_signals.py
new file mode 100644
index 000000000..149e150e0
--- /dev/null
+++ b/tests/old_functional/direct_transfer/test_signals.py
@@ -0,0 +1,149 @@
+"""
+Test the Direct Transfer feature.
+This is not a simple copy of the same test file from functional test.
+Here, we test signals transition from within the application.
+"""
+from contextlib import suppress
+from shutil import copyfile
+from time import sleep
+from unittest.mock import patch
+from uuid import uuid4
+
+from nxdrive.options import Options
+
+from .. import ensure_no_exception
+from .common import OneUserTest
+
+
+class TestDirectTransfer(OneUserTest):
+    def setUp(self):
+        # No sync root, to ease testing
+        self.remote_1.unregister_as_root(self.workspace)
+        self.engine_1.start()
+        self.engine_1.direct_transfer([], "")
+        self.dt_manager = self.engine_1.dt_manager
+
+        # Lower chunk_* options to have chunked uploads without having to create big files
+        self.default_chunk_limit = Options.chunk_limit
+        self.default_chunk_size = Options.chunk_size
+        Options.chunk_limit = 1
+        Options.chunk_size = 1
+
+        # The file used for the Direct Transfer (must be > 1 MiB)
+        source = (
+            self.location / "resources" / "databases" / "engine_migration_duplicate.db"
+        )
+        assert source.stat().st_size > 1024 * 1024
+
+        # Work with a copy of the file to allow parallel testing
+        self.file = self.tmpdir / f"{uuid4()}.bin"
+        copyfile(source, self.file)
+
+    def tearDown(self):
+        # Restore options
+        Options.chunk_limit = self.default_chunk_limit
+        Options.chunk_size = self.default_chunk_size
+
+        # Disconnect eventual signals to prevent failures when tests are run in parallel
+        with suppress(TypeError):
+            self.engine_1.directTransferDuplicateError.disconnect(
+                self.app.user_choice_cancel
+            )
+        with suppress(TypeError):
+            self.engine_1.directTransferDuplicateError.disconnect(
+                self.app.user_choice_replace
+            )
+
+    def wait_sync(self) -> None:
+        """Wait for the Direct transfer session to finish."""
+        for _ in range(30):  # 30 sec maxi
+            if not self.dt_manager.is_started:
+                break
+            sleep(1)
+
+    def sync_and_check(self, should_have_blob: bool = True) -> None:
+        # Let some time for the signal to transit (as this is async, the test would fail)
+        sleep(3)
+
+        # Sync
+        self.wait_sync()
+
+        # Check the error count
+        assert not self.engine_1.dao.get_errors(limit=0)
+
+        # Check the file exists on the server and has a blob attached
+        blob = self.has_blob()
+        assert blob is should_have_blob
+
+    def has_blob(self) -> bool:
+        """Check that *self.file* exists on the server and has a blob attached.
+        As when doing a Direct Transfer, the document is first created on the server,
+        this is the only way to check if the blob upload has been finished successfully.
+        """
+        try:
+            doc = self.root_remote.documents.get(
+                path=f"{self.ws.path}/{self.file.name}"
+            )
+        except Exception:
+            return False
+        return bool(doc.properties.get("file:content"))
+
+    def test_duplicate_file_cancellation(self):
+        """The file already exists on the server and has a blob attached.
+        Then, the user wants to cancel the transfer.
+        """
+
+        # Mimic the user clicking on "Cancel"
+        self.engine_1.directTransferDuplicateError.connect(self.app.user_choice_cancel)
+
+        def upload(*_, **__):
+            """Patch Remote.upload() to be able to check that nothing will be uploaded."""
+            assert 0, "No twice upload should be done!"
+
+        with ensure_no_exception():
+            # 1st upload: OK
+            self.engine_1.direct_transfer([self.file], self.ws.path)
+            self.sync_and_check()
+
+            # 2nd upload: it should be cancelled by the user
+            with patch.object(self.dt_manager.remote, "upload", new=upload):
+                self.engine_1.direct_transfer([self.file], self.ws.path)
+                self.sync_and_check()
+
+        # Ensure the signal was emitted
+        assert self.app.emitted
+
+        # Ensure there is only 1 document on the server
+        children = self.remote_document_client_1.get_children_info(self.workspace)
+        assert len(children) == 1
+        assert children[0].name == self.file.name
+
+    def test_duplicate_file_replace_blob(self):
+        """The file already exists on the server and has a blob attached.
+        Then, the user wants to replace the blob.
+        """
+
+        # Mimic the user clicking on "Replace"
+        self.engine_1.directTransferDuplicateError.connect(self.app.user_choice_replace)
+
+        with ensure_no_exception():
+            # 1st upload: OK
+            self.engine_1.direct_transfer([self.file], self.ws.path)
+            self.sync_and_check()
+
+            # To ease testing, we change local file content
+            self.file.write_bytes(b"blob changed!")
+
+            # 2nd upload: the blob should be replaced on the server
+            self.engine_1.direct_transfer([self.file], self.ws.path)
+            self.sync_and_check()
+
+        # Ensure the signal was emitted
+        assert self.app.emitted
+
+        # Ensure there is only 1 document on the server
+        children = self.engine_1.remote.documents.get_children(path=self.ws.path)
+        assert len(children) == 1
+        assert children[0].title == self.file.name
+        # Ensure the blob content was updated
+        assert self.engine_1.remote.get_blob(children[0].uid) == b"blob changed!"
diff --git a/tests/unit/test_engine_dao.py b/tests/unit/test_engine_dao.py
index fc32f3cf5..6e7981cf9 100644
--- a/tests/unit/test_engine_dao.py
+++ b/tests/unit/test_engine_dao.py
@@ -358,3 +358,18 @@ def test_migration_db_v10(engine_dao):
             Path("/Tests Drive/Live Connect/Test document Live Connect")
         )
         assert not bad_digest_file
+
+
+def test_migration_db_v11(engine_dao):
+    """
+    With NXDRIVE-2006, Direct Transfers were removed from the sync database.
+    Ensure that assertion is true.
+    """
+    # The test file contains 1 record of an ongoing Direct Transfer.
+    with engine_dao("engine_migration_11.db") as dao:
+        # With the v11 migration, it should have been deleted ...
+        states = list(dao.get_states_from_partial_local(Path()))
+        assert len(states) == 1  # The root
+
+        # ... And so for its related upload
+        assert not list(dao.get_uploads())
diff --git a/tools/whitelist.py b/tools/whitelist.py
index dc899d83c..944e7090f 100644
--- a/tools/whitelist.py
+++ b/tools/whitelist.py
@@ -15,6 +15,17 @@
 CliHandler.unbind_root  # Used by the arguments parser
 CliHandler.unbind_server  # Used by the arguments parser
 _.close_settings_too  # Used by Appiclation.show_filters()
+direct_transfer.manager.decrease_priority  # Used by QML
+direct_transfer.manager.increase_priority  # Used by QML
+direct_transfer.models.BaseModel.Meta  # Used by Peewee
+direct_transfer.models.BaseModel.Meta.only_save_dirty  # Used by Peewee
+direct_transfer.models.BatchField.field_type  # Used by Peewee
+direct_transfer.models.BatchField.db_value  # Used by Peewee
+direct_transfer.models.BatchField.python_value  # Used by Peewee
+direct_transfer.models.Transfer.doctype  # Used by Peewee
+direct_transfer.models.Transfer.error_count_total  # Used by Peewee
+direct_transfer.uploader.transfer.batch.service  # Used by the Nuxeo Python client
+direct_transfer.uploader.transfer.doctype  # Used by Peewee
 DocPair.last_sync_error_date  # Check NXDRIVE-1804
 Download.transfer_type  # Used in QML
 Engine.folder  # Used in QML
@@ -36,8 +47,6 @@
 on_any_event  # Used by Watchdog
 _.row_factory  # Internal use of SQLite
 Processor._synchronize_conflicted  # Used by Processor._execute()
-Processor._synchronize_direct_transfer  # Used by Processor._execute()
-Processor._synchronize_direct_transfer_replace_blob  # Used by Processor._execute()
 Processor._synchronize_deleted_unknown  # Used by Processor._execute()
 Processor._synchronize_locally_deleted  # Used by Processor._execute()
 Processor._synchronize_locally_resolved  # Used by Processor._execute()
